/*
usage :
 1) open success job
 2) find line on the bottom
    'Pass phrase is good.
rtls-api-gateway-2020.2.13-dev0.x86_64.rpm:'
 3) npm run rc 2020.2.13 0
 4) get Subject, To, Email body, yum install scripts
 */

const version = process.argv[2];
const dev = process.argv[3];
const to = ['internal-announce@redpointpositioning.com'];

if (!version) {
    throw 'Specify version';
}

if (!dev) {
    throw 'Specify dev';
}

const Body = `
rtls-api-gateway package: https://repo.rpplabs.com/centos/testing/7/updates/x86_64/rtls-api-gateway-${version}-${dev}.x86_64.rpm
rtls-api-gateway changelog: https://gitlab.rpplabs.com/dr2/rtls-api-gateway/blob/v${version}/CHANGELOG.md
`;

const InstallScripts = `
Install scripts:
sudo yum update https://repo.rpplabs.com/centos/testing/7/updates/x86_64/rtls-api-gateway-${version}-${dev}.x86_64.rpm
`;
const Subject = `Web Components. Release announce v${version}`;
const To = `${to.join(',')}`;

console.log('Subject: ');
console.log(Subject);
console.log();
console.log('To:');
console.log(To);
console.log();
console.log('Email body:', Body);
console.log(InstallScripts);
